SystemOrganization addCategory: #'IdealTrie-SP'!

Collection subclass: #TrieWithBitDict
	instanceVariableNames: 'hasValue value bitDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IdealTrie-SP'!

!TrieWithBitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/17/2012 20:24'!
valuesDo: aBlock
	"iterate over  tries for which hasValue is true"

	| bitIndex num  tmp |
	num := 31.
	self bitDictionary bitMapAsBits "might want to change this to use bitWise ops instead of iterating"
		do: [ :bit | 
			num := num - 1.
			self hasValue & (self bitDictionary bitMap = 0)
				ifTrue: [ ^ aBlock value: self value ].
			self hasValue & (self bitDictionary bitMap ~= 0) & (bit = $1)
				ifTrue: [ 
					self bitDictionary values do: [:trie | trie valuesDo: aBlock].
					^ aBlock value: self value ].
			(self hasValue = false) & (self bitDictionary bitMap ~= 0) & (bit = $1)
				ifTrue: [ 
					self bitDictionary values do: [:trie | trie valuesDo: aBlock] ] ]! !

Object subclass: #BitDict
	instanceVariableNames: 'bitMap values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IdealTrie-SP'!

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/22/2012 14:30'!
add: anObjectKey
^self at: anObjectKey put: nil  ! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/22/2012 14:30'!
at: anObjectKey! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/22/2012 17:52'!
at: anObjectKey put: anObjectValue 

	| bitIndex bitInterval |
	bitInterval := 4.
	bitIndex := self returnBitMapFromIndex: (bitInterval+1) toIndex: (bitInterval-3) fromBitMap: (anObjectKey hash).
	"if empty"
	self valuesAdd: anObjectValue withIndex: bitIndex.
	
	"if full try at: anObjectKey from left to right - 4 put: anObjectValue"


! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/17/2012 20:17'!
bitMap
^bitMap! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/17/2012 20:16'!
bitMap: smallInt
bitMap := smallInt! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/17/2012 20:16'!
countPopulationOf: n
	| SK5 SK3 SKF0 SKFF bitSet |
	SK5 := 16r15555555.
	SK3 := 16r33333333.
	SKF0 := 16rF0F0F0F.
	SKFF := 16rFF00FF.
	bitSet := n - (n >> 1 bitAnd: SK5).
	bitSet := (bitSet bitAnd: SK3) + (bitSet >> 2 bitAnd: SK3).
	bitSet := (bitSet bitAnd: SKF0) + (bitSet >> 4 bitAnd: SKF0).
	bitSet := bitSet + (bitSet >> 8).
	^ bitSet + (bitSet >> 16) bitAnd: 16r3F! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/22/2012 14:22'!
flagBit: bitIndex
	self bitMap bitAt: bitIndex put: 1! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/17/2012 20:16'!
includesCharKey: aChar
	| bitIndex val subBitMap temp|
	bitIndex := aChar charCode - 96.
	subBitMap := 0.
	(self bitMap bitAt: bitIndex) = 0
		ifTrue: [^false]
		ifFalse: [^true]! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/17/2012 20:13'!
initialize
	bitMap := 0.
	values := OrderedCollection new! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/22/2012 14:43'!
returnBitMapFromIndex: bitIndex toIndex: smallerBitIndex fromBitMap: aBitMap
	^(2 raisedTo: bitIndex - 1) - 1 bitAnd: aBitMap.! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/17/2012 20:12'!
size
	^ self countPopulationOf: bitMap! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/17/2012 20:12'!
values
^values! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/22/2012 14:48'!
valuesAdd: anObject withIndex: bitIndex
	| count subBitMap helperBitMap |
	subBitMap := 0.
	count := self values size.
	(self bitMap bitAt: bitIndex) = 0
		ifTrue: [ 
			self flagBit: bitIndex.
			count := self countPopulationOf: (self returnBitMapFromIndex: bitIndex toIndex: 1 fromBitMap: self bitMap).
			^ self values add: anObject afterIndex: count ]
		ifFalse: [ 
			count := self countPopulationOf: (self returnBitMapFromIndex: bitIndex toIndex: 1 fromBitMap: self bitMap).
			count = 0
				ifTrue: [ ^ self values add: anObject beforeIndex: 1 ]
				ifFalse: [ ^ self values add: anObject afterIndex: count ] ]	! !
